/* 
 * Copyright (c) 1996
 *      The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <stdio.h>
#include <string.h>
#include <tcp.h>
#include <netinet/in.h>

#include "a2name.h"
#include "interfac.h"

/* 
 * The DLT_RAW packet has no header. It contains a raw IP packet.
 */
void raw_if_print (u_char *user, const struct pcap_pkthdr *h, const u_char *p)
{
  static u_int32_t num_pkt = 0;
  u_int  length = h->len;
  u_int  caplen = h->caplen;

  ts_print (&h->ts);

  /*
   * Some printers want to get back at the link level addresses,
   * and/or check that they're not walking off the end of the packet.
   * Rather than pass them all the way down, we set these globals.
   */
  packetp = p;
  snapend = p + caplen;

  if (eflag)
     PUTS ("ip: ");

  ipN_print (p, length);

  if (xflag)
     default_print (p, caplen);

  PUTS ("\n");
  status_write ("Raw: %lu (%lu)", ++num_pkt, pcap_mac_packets());
}
