#
#  Makefile for tcpdump/dos. G.Vanem <giva@bgnett.no> 1998
#
#  NB. This makefile requires a real-mode Borland compatible make tool.
#      maker.exe or and old nmake will probably do fine.
#
#  Targets:
#     Metaware HighC 3.1+ (PharLap 386|DosX)
#

.AUTODEPEND

TCPDUMP_DEFS = -DTCPDUMP_VERSION="3.61" -DDEBUG -DSIZEOF_LONG_LONG=8 \
               -DUSE_CONIO -DUSE_FAST_CKSUM -DUSE_INET6 -DPRINT_DECNET_DETAILS

WATT_INC = $(WATT_ROOT)\inc
WATT_LIB = $(WATT_ROOT)\lib
RPC_LIB  = $(WATT_ROOT)\rpc\lib

PCAP_INC = .\pcap
PCAP_LIB = .\pcap

SOURCES = _afs.c _ah.c _anep.c _arp.c _ascii.c _atalk.c _atm.c _ax25.c  \
          _bgp.c _bootp.c _bxxp.c _chdlc.c _cip.c _corba.c _decnet.c    \
          _dhcp6.c _domain.c _dvmrp.c _egp.c _esp.c _ether.c _fddi.c    \
          _fr.c _frag6.c _giop.c _giop2.c _gre.c _icmp.c _icmp6.c       \
          _igrp.c _cdp.c _cnfp.c _stp.c _iiop.c _ip.c _ip6.c _ip6opts.c \
          _ipcomp.c _ipx.c _isakmp.c _isoclns.c _krb.c _llc.c _mobile.c \
          _netbios.c _oncrpc.c _lane.c _l2tp.c _lcp.c _nfs.c _radius.c  \
          _ntp.c _null.c _ospf.c _ospf6.c _pim.c _ppp.c _pppoe.c _raw.c \
          _rip.c _ripng.c _rt6.c _rx.c _sl.c _smb.c _snmp.c _srm2.c     \
          _sunrpc.c _sunrpcr.c _telnet.c _tcp.c _tftp.c _token.c _udp.c \
          _timed.c _vjc.c _vrrp.c _w3mux.c _w3ng.c _wb.c _xtp.c         \
          a2name.c config.c etherent.c out.c parsenfs.c smbutil.c       \
          tcpdump.c util.c snprintf.c savestr.c

HC_OBJ  = $(SOURCES:.c=.obj)

HC_LINK = -lib conio, hc386, hc387, hcna, dosx32, exc_hc               \
          -lib $(PCAP_LIB)\pcap_hc                                     \
          -lib $(WATT_LIB)\wattcphf, $(RPC_LIB)\rpc_hx                 \
          -offset 1000h -stack 50000 -386 -twocase -nostub             \
          -unprivileged -fullwarn -maxdata 0 -fullseg -symbols         \
          -publist both -purge none * -mapnames 30 -mapwidth 132 -pack \
        # -attributes class code  er                                   \
        # -attributes class data  rw                                   \
        # -attributes class stack rw

all: tcpdump.exp

tcpdump.exp:  hc386.arg $(HC_OBJ) $(PCAP_LIB)\pcap_hc.lib
              386link @&&|
                $(PCAP_LIB)\pkt_rx0.o32 $(HC_OBJ) -exe $<
                $(HC_LINK)
|

clean:
              @del *.obj     > nul
              @del *.map     > nul
              @del hc386.arg > nul
              @echo Cleaned

.c.obj:
              hc386.exe @hc386.arg $*.c

hc386.arg:    makefile.hc
              @copy &&|
                -w3 -c -g -O5
                -I$(WATT_INC) -I$(PCAP_INC)
                $(TCPDUMP_DEFS) -DDOSX
                -Hnocopyr
                -Hpragma=Offwarn(240,241,311,572)
                -Hpragma=stack_size_warn(6000)
                -Hon=Recognize_library
                -Hoff=Behaved
                -Hon=relax_func_ptr_rules
                -Hon=Preload_args_from_memory
                -Hon=char_is_rep
                -Hon=quiet
                -Hoff=call_trace
                -Hoff=epilog_trace
| $<

#
# Dependencies copied from makefile.dj
#
_afs.obj: _afs.c interfac.h target.h a2name.h extract.h afsops.h rx.h \
 kasops.h vlsops.h volops.h ubikops.h rxkops.h ptsops.h
_ah.obj: _ah.c interfac.h target.h a2name.h
_anep.obj: _anep.c interfac.h target.h
_arp.obj: _arp.c interfac.h target.h ethertyp.h extract.h a2name.h
_ascii.obj: _ascii.c interfac.h target.h
_atalk.obj: _atalk.c interfac.h target.h a2name.h ethertyp.h extract.h \
 appletal.h
_atm.obj: _atm.c a2name.h ethertyp.h interfac.h target.h
_ax25.obj: _ax25.c interfac.h target.h a2name.h ip.h
_bgp.obj: _bgp.c interfac.h target.h a2name.h
_bootp.obj: _bootp.c interfac.h target.h a2name.h bootp.h
_bxxp.obj: _bxxp.c interface.h target.h extract.h
_chdlc.obj: _chdlc.c ethertyp.h interfac.h target.h a2name.h ppp.h
_cip.obj: _cip.c interfac.h target.h a2name.h
_corba.obj: _corba.c interfac.h target.h a2name.h extract.h giop.h
_decnet.obj: _decnet.c decnet.h extract.h interfac.h target.h a2name.h
_dhcp6.obj: _dhcp6.c interfac.h target.h a2name.h dhcp6.h dhcp6opt.h
_domain.obj: _domain.c interfac.h target.h a2name.h extract.h
_dvmrp.obj: _dvmrp.c interfac.h target.h a2name.h
_egp.obj: _egp.c interfac.h target.h a2name.h ip.h
_esp.obj: _esp.c interfac.h target.h a2name.h ip.h ip6.h esp.h
_ether.obj: _ether.c interfac.h target.h a2name.h ethertyp.h
_fddi.obj: _fddi.c interfac.h target.h a2name.h ethertyp.h fddi.h
_fr.obj: _fr.c ethertyp.h interfac.h target.h a2name.h
_frag6.obj: _frag6.c interfac.h target.h a2name.h
_giop.obj: _giop.c interfac.h target.h a2name.h giop.h
_giop2.obj: _giop2.c interfac.h target.h a2name.h
_gre.obj: _gre.c a2name.h interfac.h target.h extract.h
_icmp.obj: _icmp.c interfac.h target.h a2name.h extract.h
_icmp6.obj: _icmp6.c interfac.h target.h a2name.h ip6.h udp.h ah.h \
 icmp6.h
_igrp.obj: _igrp.c a2name.h interfac.h target.h extract.h ip.h igrp.h
_cdp.obj: _cdp.c interfac.h target.h a2name.h extract.h
_cnfp.obj: _cnfp.c interface.h target.h tcp.h
_stp.obj: _stp.c interface.h target.h a2name.h extract.h
_iiop.obj: _iiop.c interfac.h target.h a2name.h
_ip.obj: _ip.c a2name.h interfac.h target.h extract.h ip.h
_ip6.obj: _ip6.c interfac.h target.h a2name.h ip6.h
_ip6opts.obj: _ip6opts.c interfac.h target.h a2name.h
_ipcomp.obj: _ipcomp.c interfac.h target.h a2name.h
_ipx.obj: _ipx.c interfac.h target.h a2name.h ipx.h extract.h
_isakmp.obj: _isakmp.c isakmp.h ipsec_do.h oakley.h interfac.h target.h \
 a2name.h extract.h
_isoclns.obj: _isoclns.c interfac.h target.h a2name.h ethertyp.h \
 extract.h
_krb.obj: _krb.c interfac.h target.h a2name.h
_llc.obj: _llc.c interfac.h target.h a2name.h extract.h smb.h llc.h
_mobile.obj: _mobile.c interfac.h target.h a2name.h extract.h
_netbios.obj: _netbios.c interfac.h target.h a2name.h netbios.h \
 extract.h
_oncrpc.obj: _oncrpc.c interfac.h target.h a2name.h
_lane.obj: _lane.c interfac.h target.h a2name.h lane.h
_l2tp.obj: _l2tp.c l2tp.h interfac.h target.h
_lcp.obj: _lcp.c interfac.h target.h a2name.h extract.h ppp.h
_nfs.obj: _nfs.c interfac.h target.h a2name.h extract.h nfs.h nfsfh.h
_radius.obj: _radius.c interfac.h target.h a2name.h extract.h
_ntp.obj: _ntp.c interfac.h target.h a2name.h ntp.h
_null.obj: _null.c interfac.h target.h a2name.h ip.h
_ospf.obj: _ospf.c interfac.h target.h a2name.h ip.h ospf.h
_ospf6.obj: _ospf6.c interfac.h target.h a2name.h ospf6.h
_pim.obj: _pim.c interfac.h target.h a2name.h extract.h
_ppp.obj: _ppp.c ethertyp.h interfac.h target.h a2name.h ip.h ppp.h
_pppoe.obj: _pppoe.c interfac.h target.h a2name.h ppp.h ethertyp.h \
 extract.h
_raw.obj: _raw.c a2name.h interfac.h target.h
_rip.obj: _rip.c interfac.h target.h a2name.h extract.h
_ripng.obj: _ripng.c route6d.h interfac.h target.h a2name.h
_rt6.obj: _rt6.c interfac.h target.h a2name.h
_rx.obj: _rx.c interfac.h target.h a2name.h rx.h
_sl.obj: _sl.c interfac.h target.h a2name.h extract.h
_smb.obj: _smb.c interfac.h target.h smb.h
_snmp.obj: _snmp.c interfac.h target.h a2name.h mib.h
_srm2.obj: _srm2.c interfac.h target.h
_sunrpc.obj: _sunrpc.c interfac.h target.h a2name.h
_sunrpcr.obj: _sunrpcr.c interfac.h target.h a2name.h
_telnet.obj: _telnet.c interfac.h target.h a2name.h
_tcp.obj: _tcp.c interfac.h target.h a2name.h extract.h nfs.h smb.h ip.h \
 ip6.h tcp.h
_tftp.obj: _tftp.c interfac.h target.h a2name.h
_token.obj: _token.c token.h interfac.h target.h a2name.h ethertyp.h \
 llc.h
_udp.obj: _udp.c interfac.h target.h a2name.h appletal.h nfs.h smb.h \
 bootp.h afsops.h rxkops.h ip.h ip6.h udp.h
_timed.obj: _timed.c ip.h udp.h tcp.h timed.h interfac.h target.h \
 a2name.h extract.h
_vjc.obj: _vjc.c interfac.h target.h a2name.h
_vrrp.obj: _vrrp.c interfac.h target.h extract.h a2name.h
_w3mux.obj: _w3mux.c interfac.h target.h a2name.h
_w3ng.obj: _w3ng.c interfac.h target.h a2name.h
_wb.obj: _wb.c interfac.h target.h a2name.h
_xtp.obj: _xtp.c a2name.h interfac.h target.h xtp.h
a2name.obj: a2name.c ethertyp.h interfac.h target.h llc.h a2name.h
config.obj: config.c interfac.h target.h a2name.h
etherent.obj: etherent.c
out.obj: out.c interfac.h target.h
parsenfs.obj: parsenfs.c interfac.h target.h nfsfh.h
smbutil.obj: smbutil.c interfac.h target.h smb.h
tcpdump.obj: tcpdump.c interfac.h target.h a2name.h ethertyp.h
util.obj: util.c interfac.h target.h
snprintf.obj: snprintf.c
savestr.obj: savestr.c interfac.h target.h savestr.h
