/*
 * Copyright (c) 1997
 *      The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#if 0
static const char rcsid[] =
"@(#) $Header: /tcpdump/master/tcpdump/savestr.c,v 1.4 1999/11/21 09:37:04 fenner Exp $ (LBL)";
#endif

#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>

#include "interfac.h"
#include "savestr.h"

/*
 * A replacement for strdup() that cuts down on malloc() overhead
 */
char *savestr (register const char *str)
{
  u_int   size;
  char  *p;
  static char *strptr  = NULL;
  static u_int strsize = 0;

  size = strlen (str) + 1;
  if (size > strsize)
  {
    strsize = 1024;
    if (strsize < size)
        strsize = size;
    strptr = malloc (strsize);
    if (strptr == NULL)
    {
      fprintf (stderr, "savestr: malloc\n");
      exit (1);
    }
  }
  strcpy (strptr, str);
  p = strptr;
  strptr += size;
  strsize -= size;
  return (p);
}
